/* ===================================================================
 * RegisterForm.java
 * 
 * Created Sep 30, 2004 3:18:02 PM
 * 
 * Copyright (c) 2004 Matt Magoffin (spamsqr@msqr.us)
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software 
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 
 * 02111-1307 USA
 * ===================================================================
 * $Id: RegisterForm.java 28 2009-05-04 01:19:45Z msqr $
 * ===================================================================
 */

package magoffin.matt.ieat.web;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import magoffin.matt.ieat.AuthorizationException;
import magoffin.matt.ieat.IllegalActionException;
import magoffin.matt.ieat.biz.BizContext;
import magoffin.matt.ieat.domain.UiEdit;
import magoffin.matt.ieat.domain.User;

import org.springframework.validation.BindException;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;
import org.springframework.web.servlet.ModelAndView;

/**
 * Wizard form controller for registering as a new user.
 * 
 * @author Matt Magoffin (spamsqr@msqr.us)
 * @version $Revision: 28 $ $Date: 2009-05-04 13:19:45 +1200 (Mon, 04 May 2009) $
 */
public class RegisterForm extends AbstractEatWizardForm {
	
	@Override
	protected Object formBackingObject(HttpServletRequest request)
	throws Exception 
	{
		BizContext context = WebUtil.getAnonymousBizContext(request);
		if ( !context.getAppContextSupport().isParameterTrue(BizContext.FEATURE_REGISTRATION) ) {
			throw new IllegalActionException();
		}
		UiEdit edit = getDomainObjectFactory().getUiEditInstance();
		User user = getDomainObjectFactory().getUserInstance();
		edit.setUser(user);
		return edit;
	}

	@Override
	protected void validatePage(Object command, Errors errors, int page) {
		UiEdit edit = (UiEdit)command;
		User user = edit.getUser();
		Validator val = getValidator();
		val.validate(user, errors);
	}

	@SuppressWarnings("unchecked")
	@Override
	protected ModelAndView processFinish(HttpServletRequest request,
			HttpServletResponse response, Object command, BindException errors)
			throws Exception 
	{
		Map<String, Object> model = errors.getModel();
		UiEdit edit = (UiEdit)command;
		User user = edit.getUser();
		BizContext context = WebUtil.getAnonymousBizContext(request);
		try {
			userBiz.registerUser(user, context);
		} catch ( AuthorizationException e ) {
			switch ( e.getReason() ) {
				case AuthorizationException.DUPLICATE_LOGIN:
					errors.rejectValue("user.login", "user.error.login.taken", 
							new Object[] {user.getLogin()}, "login.displayName");
					return showPage(request,errors,getInitialPage(request));
				
				case AuthorizationException.DUPLICATE_EMAIL:
					errors.rejectValue("user.email", "user.error.email.taken", 
							new Object[] {user.getEmail()}, "email.displayName");
					return showPage(request,errors,getInitialPage(request));
			}
		}
		
		model.put(WebConstants.DEFALUT_MODEL_OBJECT,edit);
		return new ModelAndView(getSuccessView(),model);
	}

}
